<?php
/*
Plugin Name: Manager WooConnect
Plugin URI: http://skysoft.co.il/
Description: תוסף לתוכנת מנג'ר לניהול העסק – תוכנת הנהלת חשבונות, מערכת מנג'ר מספקת פתרון מושלם לניהול העסק וגם תוכנה לניהול מלאי, ניתן לקבל את הפתרון של תוכנות מנג'ר בענן, לנהל את העסק במהירות מהענן. עם ממשק מלא לאתר המכירות שלכם!
Author: SkySoft
Version: 1.0
Author URI: http://skysoft.co.il/
*/

/* Adding plugin's page in admin panel */

require_once 'config.php';

function api_add_settings_page() {
    add_options_page( 'Manager WooConnect settings', 'Manager WooConnect settings', 'manage_options', "api-plugin", 'api_render_plugin_settings_page' );
}
add_action( 'admin_menu', 'api_add_settings_page' );

/* Create Settings link in Plugins Page */
add_filter('plugin_action_links_'.plugin_basename(__FILE__), 'salcode_add_plugin_page_settings_link');
function salcode_add_plugin_page_settings_link( $links ) {
    $links[] = '<a href="' .
        admin_url( 'options-general.php?page=api-plugin' ) .
        '">' . __('Settings') . '</a>';
    return $links;
}

/* Create DB table in first init */
global $jal_db_version;
$jal_db_version = "3.9";
function jal_install() {            
    global $jal_db_version;
    $siteJalDBVersion = get_option("jal_db_version", null);             

    if($jal_db_version !== $siteJalDBVersion) {
        global $wpdb;
        $table_name = $wpdb->prefix . "manager_wooconnect";
        $table_name_logs = $wpdb->prefix . "manager_wooconnect_logs";
        
        $manager_wooconnect_sql = "CREATE TABLE $table_name (
        id int(9) NOT NULL AUTO_INCREMENT,
        token text NOT NULL,
        ip text NOT NULL,
        clientUrl VARCHAR(55) NOT NULL,
        clientUrlState text NOT NULL,
        orderUrl VARCHAR(55) NOT NULL,
        orderUrlState text NOT NULL,
        productUrl VARCHAR(55) NOT NULL,
        productUrlState text NOT NULL,
        deliveryUrl VARCHAR(55) NOT NULL,
        deliveryUrlState text NOT NULL,
        invoiceUrl VARCHAR(55) NOT NULL,
        invoiceUrlState text NOT NULL,
        stockStatus text NOT NULL DEFAULT ('manual'),
        stockUpdateMethod text NOT NULL DEFAULT ('" . STOCK_IN . "'),
        itemIdField text NOT NULL DEFAULT ('" . ITEM_ID . "'),
        PRIMARY KEY  id (id)
        );";
        
        $manager_wooconnect_logs_sql = "CREATE TABLE $table_name_logs (
        log_id int(9) NOT NULL AUTO_INCREMENT,
        timestamp text NOT NULL,
        level text NOT NULL,
        source text NOT NULL,
        message text NOT NULL,
        request text NOT NULL,
        response text NOT NULL,
        PRIMARY KEY  id (log_id)
        );";

        require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
        dbDelta($manager_wooconnect_sql); 
        dbDelta($manager_wooconnect_logs_sql);                        
        
        $wpdb->insert($table_name, array('id' => 1));               
        
        if($siteJalDBVersion === null) {
            add_option("jal_db_version", $jal_db_version);   
        }
        else {
            update_option("jal_db_version", $jal_db_version);   
        }        
    }       
}
register_activation_hook(__FILE__,'jal_install');

require_once 'parts/render_plugin.php';

require_once 'parts/ajax_handlers.php';

require_once 'parts/handlers.php';

/* Send product */
add_action( 'save_post', 'save_product_data', 10, 3 );
function save_product_data( $post_ID, $post, $update ) {
    $post_type = get_post_type( $post_ID );

    if ( wp_is_post_revision( $post_ID ) || get_post($post_ID)->post_status != 'publish' )
        return;

    if($post_type === 'product') {
        wooconnect_update_products_not_ajax( $post_ID );
    } else return;
}

/* Send User */
add_action('user_register','post_user_reg_redirect');
function post_user_reg_redirect( $user_id )
{
    $user_info = get_userdata( $user_id );

    if ( is_admin() ) {

        $user_data = array(
            "id" => $user_info->ID,
            "providerId" => "",
            "name" => $user_info->first_name. ' ' . $last_name  = $user_info->last_name,
            "address" => get_user_meta( $user_info->ID, 'billing_address_1', true ) . ' ' . get_user_meta( $user_info->ID, 'billing_address_1', true ),
            "city" => get_user_meta( $user_info->ID, 'billing_city', true ),
            "zipCode" => get_user_meta( $user_info->ID, 'billing_postcode', true ),
            "phone1" => get_user_meta( $user_info->ID, 'billing_phone', true ),
            "phone2" => '',
            "fax" => "",
            "email" => $user_info->user_email,
            "osekNo" => "",
            "sortCode1" => '',
            "sortCode2" => '',
            "sortCode3" => '',
            "sortCode4" => '',
            "sortCode5" => '',
            "sortCode6" => '',
            "vatFlag" => "",
            "comercialReduc" => '',
            "creditLevel" => '',
            "createdDate" => "",
            "updatedDate" => ""
        );

        $search_c_f = search_contact( $user_info->ID );
        $search_arr = json_decode($search_c_f, true);

        /* Проверяем, есть ли пользователь в системе не сервере */
        if($search_arr['rowCount'] === 0 ) {
            /* Пользователя нет в системе, добавляем пользователя */
            add_contact( $user_id, $user_data );
        } else {
            /* Пользователь есть в системе, обновляем данные */
            update_contact( $user_id, $user_data );
        }

    }

}

add_action( 'profile_update', 'my_profile_update', 10, 2 );
function my_profile_update( $user_id, $old_user_data ) {
    $user_info = get_userdata( $user_id );

    if ( is_admin() ) {

        $user_data = array(
            "id" => $user_info->ID,
            "providerId" => "",
            "name" => $user_info->first_name. ' ' . $last_name  = $user_info->last_name,
            "address" => get_user_meta( $user_info->ID, 'billing_address_1', true ) . ' ' . get_user_meta( $user_info->ID, 'billing_address_1', true ),
            "city" => get_user_meta( $user_info->ID, 'billing_city', true ),
            "zipCode" => get_user_meta( $user_info->ID, 'billing_postcode', true ),
            "phone1" => get_user_meta( $user_info->ID, 'billing_phone', true ),
            "phone2" => '',
            "fax" => "",
            "email" => $user_info->user_email,
            "osekNo" => "",
            "sortCode1" => '',
            "sortCode2" => '',
            "sortCode3" => '',
            "sortCode4" => '',
            "sortCode5" => '',
            "sortCode6" => '',
            "vatFlag" => "",
            "comercialReduc" => '',
            "creditLevel" => '',
            "createdDate" => "",
            "updatedDate" => ""
        );

        $search_c_f = search_contact( $user_info->ID );
        $search_arr = json_decode($search_c_f, true);

        /* Проверяем, есть ли пользователь в системе не сервере */
        if($search_arr['rowCount'] === 0 ) {
            /* Пользователя нет в системе, добавляем пользователя */
            add_contact( $user_id, $user_data );
        } else {
            /* Пользователь есть в системе, обновляем данные */
            update_contact( $user_id, $user_data );
        }

//        /* Проверяем, есть ли пользователь в системе не сервере */
//        if(!empty( search_contact( $user_id ) ) ) {
//            /* Пользователь есть в системе, обновляем данные */
//            update_contact( $user_id, $user_data );
//        } else {
//            /* Пользователя нет в системе, добавляем пользователя */
//            add_contact( $user_id, $user_data );
//        }
    }
}

/* Sending data after order is created */
add_action( 'woocommerce_checkout_order_created', 'action_woocommerce_new_order', 10, 3 );

function action_woocommerce_new_order($order_id){
    global $wpdb;
    $table_name = $wpdb->prefix . "manager_wooconnect";
    $table_name_logs = $wpdb->prefix . "manager_wooconnect_logs";
    $table_name_clients = $wpdb->prefix . "manager_wooconnect_clients";
    $db_query = $wpdb->get_results( "SELECT * FROM ".$table_name. " WHERE id = 1" );
    $itemIdField = $db_query[0]->itemIdField;

    $table_woocommerce_order_itemmeta = $wpdb->prefix . "order_itemmeta";
    $table_woocommerce_order_items = $wpdb->prefix . "woocommerce_order_items";

    $order = wc_get_order( $order_id );

    $data = $order->get_data();

    $items_in_order = array();

    $line_num = 0;

    foreach( $order->get_items() as $item_id => $item ){
        $wc_product = $item->get_product(); // the WC_Product object

        // данные элемента заказа в виде массива
        $item_data = $item->get_data();

        if($wc_product->get_tax_status() === 'none' || $wc_product->get_tax_status() === 'shipping') {
            $vat_flag = false;
        } else { $vat_flag = true; }


        if($wc_product->get_length() === '') {
            $length = 0;
        } else {
            $length = $wc_product->get_length();
        }

        if($wc_product->get_width() === '') {
            $width = 0;
        } else {
            $width = $wc_product->get_width();
        }

        if($wc_product->get_weight() === '') {
            $weight = 0;
        } else {
            $weight = $wc_product->get_weight();
        }

        $itemId = $item['product_id'];
        $barcode = $wc_product->get_sku();        
        if($itemIdField == ITEM_SKU && !empty($barcode)) {
            $itemId = $barcode;
            $barcode = '';
        }
        
        $item_data_single = array(
            "lineNo" => $line_num,
            "itemId" => $itemId,
            "itemName" => $item['name'],
            "barcode" => $barcode,
            "auxcode" => $barcode,
            "color" => $wc_product->get_attribute('pa_color'),
            "notes" => "",
            "provisionDate" => null,
            "length" => $length,
            "width" => $width,
            "thickness" => 0,
            "weight" => $weight,
            "packType" => $item->get_meta( '_price_by', true ),
            "packsInLot" => (int) $item->get_meta( '_price_by_quantity', true ),
            "unitsInPack" => null,
            "quantity" => $item['quantity'],
            "unitPriceBeforeVAT"=> $item['total'] / $item['quantity'],
            "unitPrice" => $item['total'] / $item['quantity'],
            "discount" => 0.0,
            "salePriceBeforeVAT" => $item['total'],
            "VatFlag" => $vat_flag,

        );
        $line_num++;
        array_push($items_in_order, $item_data_single);
    }

    $client_email = $data['billing']['email'];
    $users = new WP_User_Query( array(
        'search'         => '*'.esc_attr( $client_email ).'*',
        'search_columns' => array(
            'user_email',
        ),
    ) );
    $users_found = $users->get_results();

    $wpdb->insert($table_name_logs,
            array(
                'timestamp' => date('l jS \of F Y h:i:s A'),
                //'message' => $log_message,
                'level' => 'User creation WP',
                'source' => $users_found[0]->ID
            ));
    create_log('localhost', 'Search user in WP database', $users_found);

    if(empty($users_found[0]->ID)) {
        $user_id = wp_insert_user( array(
            'user_login' => $client_email = $data['billing']['email'],
            'user_pass' => 'testpass',
            'user_email' => $client_email = $data['billing']['email'],
            'first_name' => $client_email = $data['billing']['first_name'],
            'last_name' => $client_email = $data['billing']['last_name'],
            'display_name' => $client_email = $data['billing']['first_name']. ' ' .$client_email = $data['billing']['last_name'],
            'role' => 'customer'
        ));

        $order_data = array(
            "header" => array (
                "documentId" => $order->get_order_number(),
                "docNo" => $order->get_order_number(),
                "accountId" => $user_id,
                "accountName" => $data['billing']['first_name'].' '.$data['billing']['last_name'],
                "address" => $data['billing']['address_1'].''.$data['billing']['address_2'],
                "city" => $data['billing']['city'],
                "contact" => $data['billing']['first_name'].' '.$data['billing']['last_name'],
                "phone1" => $data['billing']['phone'],
                "phone2" => $data['billing']['phone'],
                "phone3" => null,
                "phone4" => null,
                "subjectId" => 0,
                "agentId" => 0,
                "agentName" => $data['billing']['first_name'],
                "notes" => "notes",
                "storeNo" => 1,
                "asmac" => null,
                "provisionDate" => null,
                "returnDate" => null,
                "systemStatus" => 0,
                "status" => null,
                "subTotal" => 0,
                "discount" => $order->get_total_discount(),
                "totalBeforeVat" => $order->get_total(),
                "vat" => 17,
                "total" => $order->get_total(),
                "paid" => 0,
                "createdDate" => null,
                "updatedDate" => null
            ),
            "body" => $items_in_order
        );

        $user_data = array(
            "id" => $user_id,
            "providerId" => "",
            "name" => $data['billing']['first_name'].' '.$data['billing']['last_name'],
            "address" => $data['billing']['address_1'].''.$data['billing']['address_2'],
            "city" => $data['billing']['city'],
            "zipCode" => "",
            "phone1" => $data['billing']['phone'],
            "phone2" => $data['billing']['phone'],
            "fax" => "",
            "email" => $data['billing']['email'],
            "osekNo" => "",
            "sortCode1" => '',
            "sortCode2" => '',
            "sortCode3" => '',
            "sortCode4" => '',
            "sortCode5" => '',
            "sortCode6" => '',
            "vatFlag" => "",
            "comercialReduc" => '',
            "creditLevel" => '',
            "createdDate" => "",
            "updatedDate" => ""
        );

        $search_c_f = search_contact( $user_id );
        $search_arr = json_decode($search_c_f, true);

        if($search_arr['rowCount'] === 0 ) {
            add_contact( $user_id, $user_data );
            add_order($order_data);
        } else {
            update_contact( $user_id, $user_data );
            add_order($order_data);
        }

    }

    else {

        $user_id = $users_found[0]->ID;

        $order_data = array(
            "header" => array (
                "documentId" => $order->get_order_number(),
                "docNo" => $order->get_order_number(),
                "accountId" => $user_id,
                "accountName" => $data['billing']['first_name'].' '.$data['billing']['last_name'],
                "address" => $data['billing']['address_1'].''.$data['billing']['address_2'],
                "city" => $data['billing']['city'],
                "contact" => $data['billing']['first_name'].' '.$data['billing']['last_name'],
                "phone1" => $data['billing']['phone'],
                "phone2" => $data['billing']['phone'],
                "phone3" => null,
                "phone4" => null,
                "subjectId" => 0,
                "agentId" => 0,
                "agentName" => $data['billing']['first_name'],
                "notes" => "notes",
                "storeNo" => 1,
                "asmac" => null,
                "provisionDate" => null,
                "returnDate" => null,
                "systemStatus" => 0,
                "status" => null,
                "subTotal" => 0,
                "discount" => $order->get_total_discount(),
                "totalBeforeVat" => $order->get_total(),
                "vat" => 17,
                "total" => $order->get_total(),
                "paid" => 0,
                "createdDate" => null,
                "updatedDate" => null
            ),
            "body" => $items_in_order
        );

        $user_data = array(
            "id" => $user_id,
            "providerId" => "",
            "name" => $data['billing']['first_name'].' '.$data['billing']['last_name'],
            "address" => $data['billing']['address_1'].''.$data['billing']['address_2'],
            "city" => $data['billing']['city'],
            "zipCode" => "",
            "phone1" => $data['billing']['phone'],
            "phone2" => $data['billing']['phone'],
            "fax" => "",
            "email" => $data['billing']['email'],
            "osekNo" => "",
            "sortCode1" => '',
            "sortCode2" => '',
            "sortCode3" => '',
            "sortCode4" => '',
            "sortCode5" => '',
            "sortCode6" => '',
            "vatFlag" => "",
            "comercialReduc" => '',
            "creditLevel" => '',
            "createdDate" => "",
            "updatedDate" => ""
        );

        $search_c_f = search_contact( $user_id );
        $search_arr = json_decode($search_c_f, true);

        if($search_arr['rowCount'] === 0 ) {
            add_contact( $user_id, $user_data );
            add_order($order_data);
        } else {
            update_contact( $user_id, $user_data );
            add_order($order_data);
        }

    }

    $request_header = array(
        'Content-type: application/json',
        'Authorization: Bearer '.$db_query[0]->token,
    );

    if($db_query[0]->deliveryUrlState === 'true') { // DELIVERY NOTE
        send_delivery($request_header, $db_query[0]->ip, json_encode($order_data));
    }

    if($db_query[0]->invoiceUrlState === 'true') { // INVOICE
        $myCurl = curl_init();
        curl_setopt_array($myCurl, array(
            CURLOPT_URL => 'http://'.$db_query[0]->ip.':59312/invoice',
            CURLOPT_HTTPHEADER => $request_header,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_POST => true,
            CURLOPT_POSTFIELDS => json_encode($order_data)
        ));
        $response = curl_exec($myCurl);
        curl_close($myCurl);

        $log_message = 'Invoice response: ' . strval($response);

        $wpdb->insert($table_name_logs,
            array(
                'timestamp' => date('l jS \of F Y h:i:s A'),
                'message' => $log_message,
                'level' => 'http://'.$db_query[0]->ip.':59312/invoice',
                'source' => json_encode($order_data)
            ));
    }

}

require_once 'parts/functions.php';








