<?php

function action_woocommerce_new_order($order_id){
    global $wpdb;
    $table_name = $wpdb->prefix . "manager_wooconnect";
    $table_name_logs = $wpdb->prefix . "manager_wooconnect_logs";
    $table_name_clients = $wpdb->prefix . "manager_wooconnect_clients";
    $db_query = $wpdb->get_results( "SELECT * FROM ".$table_name. " WHERE id = 1" );

    $order = wc_get_order( $order_id );

    $data = $order->get_data();

    $items_in_order = array();

    $line_num = 0;

    foreach( $order->get_items() as $item_id => $item ){

        // методы класса WC_Order_Item

        // ID элемента можно получить из ключа массива или так:
        $item_id = $item->get_id();

        // методы класса WC_Order_Item_Product

        $item_name = $item->get_name(); // Name of the product
        $item_type = $item->get_type(); // Type of the order item ("line_item")

        $product_id = $item->get_product_id(); // the Product id
        $wc_product = $item->get_product(); // the WC_Product object

        // данные элемента заказа в виде массива
        $item_data = $item->get_data();

        $item_data_single = array(
            "lineNo" => $line_num,
            "itemId" => $item['product_id'],
            "itemName" => $item_data['name'],
            "barcode" => $wc_product->get_sku(),
            "auxcode" => $wc_product->get_sku(),
            "color" => "0",
            "notes" => "0",
            "provisionDate" => null,
            "length" => 0,
            "width" => 0,
            "thickness" => 0.0,
            "weight" => 0.0,
            "packType" => null,
            "packsInLot" => null,
            "unitsInPack" => null,
            "quantity" => $item_data['quantity'],
            //"unitPriceBeforeVAT"=> floatval($wc_product->get_price()),
            "unitPriceBeforeVAT"=> $wc_product->get_price(),
            //"unitPriceBeforeVAT"=> $item_data['total'] / $item_data['quantity'],
            //"unitPrice" => $item_data['total'] / $item_data['quantity'],
            "unitPrice" => $wc_product->get_price(),
            //"unitPrice" => floatval($wc_product->get_price()),
            "discount" => 0.0,
            "salePriceBeforeVAT" => $item_data['total']
        );
        $line_num++;
        array_push($items_in_order, $item_data_single);
    }

    $order_header = array(
        'Content-type: application/json',
        'Authorization: Bearer '.$db_query[0]->token,
    );


    // Проверяем наличие клиента и создаем JSON заказа
    $client_email = $data['billing']['email'];
    $db_query_client = $wpdb->get_results( "SELECT * FROM ".$table_name_clients. " WHERE email = '$client_email'" );

    /* Если клиента нет в базе данных */
    if(empty($db_query_client)) {
        /* Создаем клиента в нашей таблице */
        $wpdb->insert($table_name_clients,
            array(
                'name' => $data['billing']['first_name'],
                'lastName' => $data['billing']['last_name'],
                'phone' => $data['billing']['phone'],
                'email' => $data['billing']['email']
            ));
        /* Получаем id вновь созданного клиента */
        $db_query_new_client = $wpdb->get_results( "SELECT * FROM ".$table_name_clients. " WHERE email = '$client_email'" );

        /* Создаем в системе нового клиента */
        $post_account = array(
            "id" => $db_query_new_client[0]->client_id,
            "providerId" => "",
            "name" => $data['billing']['first_name'].' '.$data['billing']['last_name'],
            "address" => $data['billing']['address_1'].''.$data['billing']['address_2'],
            "city" => $data['billing']['city'],
            "zipCode" => "",
            "phone1" => $data['billing']['phone'],
            "phone2" => $data['billing']['phone'],
            "fax" => "",
            "email" => $data['billing']['email'],
            "osekNo" => "",
            "sortCode1" => '',
            "sortCode2" => '',
            "sortCode3" => '',
            "sortCode4" => '',
            "sortCode5" => '',
            "sortCode6" => '',
            "vatFlag" => "",
            "comercialReduc" => '',
            "creditLevel" => '',
            "createdDate" => "",
            "updatedDate" => ""
        );
        $myCurl = curl_init();
        curl_setopt_array($myCurl, array(
            CURLOPT_URL => 'http://'.$db_query[0]->ip.':59310/account',
            CURLOPT_HTTPHEADER => $order_header,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_POST => true,
            CURLOPT_POSTFIELDS => json_encode($post_account)
        ));
        $response = curl_exec($myCurl);
        curl_close($myCurl);

        $log_message = 'Client response: ' . strval($response);

        $wpdb->insert($table_name_logs,
            array(
                'timestamp' => date('l jS \of F Y h:i:s A'),
                'message' => $log_message,
                'source' => json_encode($post_account),
                'level' => 'http://'.$db_query[0]->ip.':59310/account'
            ));

        /* Отправляем данные о заказе в систему */
        $post_order = array(
            "header" => array (
                "documentId" => $order->get_order_number(),
                "docNo" => $order->get_order_number(),
                "accountId" => $db_query_new_client[0]->client_id,
                "accountName" => $data['billing']['first_name'].' '.$data['billing']['last_name'],
                "address" => $data['billing']['address_1'].''.$data['billing']['address_2'],
                "city" => $data['billing']['city'],
                "contact" => $data['billing']['first_name'].' '.$data['billing']['last_name'],
                "phone1" => $data['billing']['phone'],
                "phone2" => $data['billing']['phone'],
                "phone3" => null,
                "phone4" => null,
                "subjectId" => 0,
                "agentId" => 0,
                "agentName" => $data['billing']['first_name'],
                "notes" => "notes",
                "storeNo" => 1,
                "asmac" => null,
                "provisionDate" => null,
                "returnDate" => null,
                "systemStatus" => 0,
                "status" => null,
                "subTotal" => 0,
                "discount" => $order->get_total_discount(),
                "totalBeforeVat" => $order->get_total(),
                "vat" => 17,
                "total" => $order->get_total(),
                "paid" => 0,
                "createdDate" => null,
                "updatedDate" => null
            ),
            "body" => $items_in_order
        );
    }
    /* Если клиент с таким именем и email уже ранее делал заказ */
    else {
        $post_order = array(
            "header" => array (
                "documentId" => $order->get_order_number(),
                "docNo" => $order->get_order_number(),
                "accountId" => $db_query_client[0]->client_id,
                "accountName" => $data['billing']['first_name'].' '.$data['billing']['last_name'],
                "address" => $data['billing']['address_1'].''.$data['billing']['address_2'],
                "city" => $data['billing']['city'],
                "contact" => $data['billing']['first_name'].' '.$data['billing']['last_name'],
                "phone1" => $data['billing']['phone'],
                "phone2" => $data['billing']['phone'],
                "phone3" => null,
                "phone4" => null,
                "subjectId" => 0,
                "agentId" => 0,
                "agentName" => $data['billing']['first_name'],
                "notes" => "notes",
                "storeNo" => 1,
                "asmac" => null,
                "provisionDate" => null,
                "returnDate" => null,
                "systemStatus" => 0,
                "status" => null,
                "subTotal" => 0,
                "discount" => $order->get_total_discount(),
                "totalBeforeVat" => $order->get_total(),
                "vat" => 17,
                "total" => $order->get_total(),
                "paid" => 0,
                "createdDate" => null,
                "updatedDate" => null
            ),
            "body" => $items_in_order
        );
    }


    if($db_query[0]->orderUrlState === 'true') {
        send_request($order_header, $db_query[0]->ip, json_encode($post_order));
    }

    if($db_query[0]->clientUrlState === 'true') {
//        $myCurl = curl_init();
//        curl_setopt_array($myCurl, array(
//            CURLOPT_URL => 'http://'.$db_query[0]->ip.':59310/account',
//            CURLOPT_HTTPHEADER => $order_header,
//            CURLOPT_RETURNTRANSFER => true,
//            CURLOPT_POST => true,
//            CURLOPT_POSTFIELDS => json_encode($post_account)
//        ));
//        $response = curl_exec($myCurl);
//        curl_close($myCurl);
//
//        $log_message = 'Client response: ' . strval($response);
//
//        $wpdb->insert($table_name_logs,
//            array(
//                'timestamp' => date('l jS \of F Y h:i:s A'),
//                'message' => $log_message,
//                'level' => 'http://'.$db_query[0]->ip.':59310/account'
//            ));
    }

    if($db_query[0]->productUrlState === 'true') {
//        $myCurl = curl_init();
//        curl_setopt_array($myCurl, array(
//            CURLOPT_URL => 'http://'.$db_query[0]->ip.':59311/item',
//            CURLOPT_HTTPHEADER => $order_header,
//            CURLOPT_RETURNTRANSFER => true,
//            CURLOPT_POST => true,
//            CURLOPT_POSTFIELDS => json_encode($post_order)
//        ));
//        $response = curl_exec($myCurl);
//        curl_close($myCurl);
//
//        $log_message = 'Product response: ' . strval($response);
//
//        $wpdb->insert($table_name_logs,
//            array(
//                'timestamp' => date('l jS \of F Y h:i:s A'),
//                'message' => $log_message,
//                'level' => 'http://'.$db_query[0]->ip.':59311/item',
//                'source' => json_encode($post_product)
//            ));
    }

    if($db_query[0]->deliveryUrlState === 'true') { // DELIVERY NOTE
        send_delivery($order_header, $db_query[0]->ip, json_encode($post_order));
    }

    if($db_query[0]->invoiceUrlState === 'true') {
        $myCurl = curl_init();
        curl_setopt_array($myCurl, array(
            CURLOPT_URL => 'http://'.$db_query[0]->ip.':59312/invoice',
            CURLOPT_HTTPHEADER => $order_header,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_POST => true,
            CURLOPT_POSTFIELDS => json_encode($post_order)
        ));
        $response = curl_exec($myCurl);
        curl_close($myCurl);

        $log_message = 'Invoice response: ' . strval($response);

        $wpdb->insert($table_name_logs,
            array(
                'timestamp' => date('l jS \of F Y h:i:s A'),
                'message' => $log_message,
                'level' => 'http://'.$db_query[0]->ip.':59312/invoice',
                'source' => json_encode($post_order)
            ));
    }
}