<?php

/* AJAX Handler */
function wooconnect_update_data(){
    global $wpdb;
    $table_name = $wpdb->prefix . "manager_wooconnect";

    $data = $_POST['data'];
    $data_json = json_decode(stripslashes($data));

    $wpdb->update($table_name,
        array(
            'token' => $data_json->token,
            'ip' => $data_json->ip,
            'clientUrl' => $data_json->clientUrl,
            'clientUrlState' => $data_json->clientUrlState,
            'orderUrl' => $data_json->orderUrl,
            'orderUrlState' => $data_json->orderUrlState,
            'productUrl' => $data_json->productUrl,
            'productUrlState' => $data_json->productUrlState,
            'deliveryUrl' => $data_json->deliveryUrl,
            'deliveryUrlState' => $data_json->deliveryUrlState,
            'invoiceUrl' => $data_json->invoiceUrl,
            'invoiceUrlState' => $data_json->invoiceUrlState,
            'stockStatus' => $data_json->stockStatus,
            'stockUpdateMethod' => $data_json->stockUpdateMethod,
            'itemIdField' => $data_json->itemIdField
        ),
        array('id' => '1'));
        
        // cron jobs
        global $wpdb;
        $table_name = $wpdb->prefix . "manager_wooconnect";
        $db_query = $wpdb->get_results( "SELECT * FROM $table_name WHERE id = 1" );
        if($db_query[0]->stockStatus !== $data_json->stockStatus) {
            wp_unschedule_hook("cm_cron_update_schedule");
            switch($data_json->stockStatus) {
                case 'half':
                    wp_schedule_event( time(), 'thirty_min', 'cm_cron_update_schedule');
                    break;
                case 'hour':
                    wp_schedule_event( time(), 'hourly', 'cm_cron_update_schedule');
                    break;
                case 'day':
                    wp_schedule_event( time(), 'daily', 'cm_cron_update_schedule');
                    break;
                default:                    
                    break;
            }                        
        }            
        
    die();
}
add_action('wp_ajax_wooconnect', 'wooconnect_update_data');

function wooconnect_update_products() {
    $id = $_POST['id'];

    global $wpdb;
    $table_name = $wpdb->prefix . "manager_wooconnect";
    $db_query = $wpdb->get_results( "SELECT * FROM ".$table_name. " WHERE id = 1" );
    $order_header = array(
        'Content-type: application/json',
        'Authorization: Bearer '.$db_query[0]->token,
    );

    $product = wc_get_product( $id );

    $post_product = array(
        "id" => $id,
        "barcode" => "",
        "providerId" => "",
        "itemNameHE" => $product->get_title(),
        "itemNameEN" => $product->get_title(),
        "unit" => "",
        "characteristic1" => "",
        "characteristic2" => "",
        "sortCode1" => "",
        "sortCode2" => "",
        "sortCode3" => "",
        "vatFlag" => "",
        "price1" => $product->get_price(),
        "price2" => $product->get_regular_price(),
        "price3" => $product->get_sale_price(),
        "price4" => "",
        "price5" => "",
        "price6" => "",
        "price7" => "",
        "price8" => "",
        "price9" => "",
        "price10" => "",
        "currencyCode1" => get_woocommerce_currency_symbol(),
        "currencyCode2" => "",
        "currencyCode3" => "",
        "currencyCode4" => "",
        "currencyCode5" => "",
        "currencyCode6" => "",
        "currencyCode7" => "",
        "currencyCode8" => "",
        "currencyCode9" => "",
        "currencyCode10" => "",
        "supplerId1" => "",
        "supplerId2" => "",
        "supplerId3" => "",
        "supplerId4" => "",
        //"createdDate" => $product->get_date_created()->date,
        //"updatedDate" => $product->get_date_modified()
    );

    $myCurl = curl_init();
    curl_setopt_array($myCurl, array(
        CURLOPT_URL => 'http://'.$db_query[0]->ip.':59311/item',
        CURLOPT_HTTPHEADER => $order_header,
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_POST => true,
        CURLOPT_POSTFIELDS => json_encode($post_product)
    ));
    $response = curl_exec($myCurl);
    curl_close($myCurl);
    var_dump($response);

    die();

}
add_action('wp_ajax_wooconnectstock', 'wooconnect_update_products');

/* Put item in stock. Update item data */
function wooconnect_put_item() {
    $id = $_POST['id'];
    global $wpdb;
    $table_name = $wpdb->prefix . "manager_wooconnect";
    $db_query = $wpdb->get_results( "SELECT * FROM ".$table_name. " WHERE id = 1" );
    $order_header = array(
        'Content-type: application/json',
        'Authorization: Bearer '.$db_query[0]->token,
    );
    $product = wc_get_product( $id );
    $post_product = array(
        "id" => $id,
        "barcode" => "",
        "providerId" => "",
        "itemNameHE" => $product->get_title(),
        "itemNameEN" => $product->get_title(),
        "unit" => "",
        "characteristic1" => "",
        "characteristic2" => "string",
        "sortCode1" => "",
        "sortCode2" => "",
        "sortCode3" => "",
        "vatFlag" => "",
        "price1" => $product->get_price(),
        "price2" => $product->get_regular_price(),
        "price3" => $product->get_sale_price(),
        "price4" => "",
        "price5" => "",
        "price6" => "",
        "price7" => "",
        "price8" => "",
        "price9" => "",
        "price10" => "",
        "currencyCode1" => get_woocommerce_currency_symbol(),
        "currencyCode2" => "",
        "currencyCode3" => "",
        "currencyCode4" => "",
        "currencyCode5" => "",
        "currencyCode6" => "",
        "currencyCode7" => "",
        "currencyCode8" => "",
        "currencyCode9" => "",
        "currencyCode10" => "",
        "supplerId1" => "",
        "supplerId2" => "",
        "supplerId3" => "",
        "supplerId4" => "",
        //"createdDate" => $product->get_date_created()->date,
        //"updatedDate" => $product->get_date_modified()
    );
    $myCurl = curl_init();
    curl_setopt_array($myCurl, array(
        CURLOPT_URL => 'http://'.$db_query[0]->ip.':59311/item',
        CURLOPT_HTTPHEADER => $order_header,
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_CUSTOMREQUEST => "PUT",
        CURLOPT_POSTFIELDS => json_encode($post_product)
    ));
    $response = curl_exec($myCurl);
    curl_close($myCurl);
    var_dump($response);

    die();
}
add_action('wp_ajax_wooconnectputitem', 'wooconnect_put_item');

/* Get all products' id */
function get_all_products_id() {
    $args = array(
        'post_type' => 'product'
    );

    $loop = new WP_Query( $args );

    $product_ids = array();

    while ( $loop->have_posts() ) : $loop->the_post();
        global $product;

        array_push($product_ids, get_the_ID());

    endwhile;

    echo json_encode($product_ids);

    die();
}
add_action('wp_ajax_getallproducts', 'get_all_products_id');


function wooconnect_update_products_not_ajax($id) {
    global $wpdb;
    $table_name = $wpdb->prefix . "manager_wooconnect";
    $table_name_logs = $wpdb->prefix . "manager_wooconnect_logs";
    $db_query = $wpdb->get_results( "SELECT * FROM ".$table_name. " WHERE id = 1" );
    $order_header = array(
        'Content-type: application/json',
        'Authorization: Bearer '.$db_query[0]->token,
    );

    $product = wc_get_product( $id );

    $search_product = array('itemId' => $id);

    $post_product = array(
        "id" => $id,
        "barcode" => $product->get_sku(),
        "providerId" => "",
        "itemNameHE" => $product->get_title(),
        "itemNameEN" => $product->get_title(),
        "unit" => "",
        "characteristic1" => "",
        "characteristic2" => "",
        "sortCode1" => "",
        "sortCode2" => "",
        "sortCode3" => "",
        "vatFlag" => "",
        "price1" => $product->get_price(),
        "price2" => $product->get_regular_price(),
        "price3" => $product->get_sale_price(),
        "price4" => "",
        "price5" => "",
        "price6" => "",
        "price7" => "",
        "price8" => "",
        "price9" => "",
        "price10" => "",
        "currencyCode1" => get_woocommerce_currency_symbol(),
        "currencyCode2" => "",
        "currencyCode3" => "",
        "currencyCode4" => "",
        "currencyCode5" => "",
        "currencyCode6" => "",
        "currencyCode7" => "",
        "currencyCode8" => "",
        "currencyCode9" => "",
        "currencyCode10" => "",
        "supplerId1" => "",
        "supplerId2" => "",
        "supplerId3" => "",
        "supplerId4" => "",
        //"createdDate" => $product->get_date_created()->date,
        //"updatedDate" => $product->get_date_modified()
    );

    $myCurl = curl_init();
    curl_setopt_array($myCurl, array(
        CURLOPT_URL => 'http://'.$db_query[0]->ip.':59311/item/search',
        CURLOPT_HTTPHEADER => $order_header,
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_POST => true,
        CURLOPT_POSTFIELDS => json_encode($search_product)
    ));
    $response = curl_exec($myCurl);
    curl_close($myCurl);

    $found_item = json_decode($response);

    if($found_item->rowCount === 0) {
        $myCurl = curl_init();
        curl_setopt_array($myCurl, array(
            CURLOPT_URL => 'http://'.$db_query[0]->ip.':59311/item',
            CURLOPT_HTTPHEADER => $order_header,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_POST => true,
            CURLOPT_POSTFIELDS => json_encode($post_product)
        ));
        $response = curl_exec($myCurl);
        curl_close($myCurl);

        $wpdb->insert($table_name_logs,
            array(
                'timestamp' => date('l jS \of F Y h:i:s A'),
                'message' => 'Product has been added with id: '.$response,
                'level' => 'http://'.$db_query[0]->ip.':59311/item',
                'source' => json_encode($post_product)
            ));
    } else {
        $myCurl = curl_init();
        curl_setopt_array($myCurl, array(
            CURLOPT_URL => 'http://'.$db_query[0]->ip.':59311/item',
            CURLOPT_HTTPHEADER => $order_header,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_CUSTOMREQUEST => "PUT",
            CURLOPT_POSTFIELDS => json_encode($post_product)
        ));
        $response = curl_exec($myCurl);
        curl_close($myCurl);

        $wpdb->insert($table_name_logs,
            array(
                'timestamp' => date('l jS \of F Y h:i:s A'),
                'message' => 'Product with id: '.$response.' has been updated',
                'level' => 'http://'.$db_query[0]->ip.':59311/item',
                'source' => json_encode($post_product)
            ));
    }
}