<?php

require_once dirname(__FILE__) . '/../config.php';

global $wpdb;
$table_name = $wpdb->prefix . "manager_wooconnect";
$db_query = $wpdb->get_results("SELECT * FROM " . $table_name . " WHERE id = 1");
$request_header = array(
    'Content-type: application/json',
    'Authorization: Bearer ' . $db_query[0]->token,
);
$request_ip = $db_query[0]->ip;

function search_contact($id) {
    global $request_header;
    global $request_ip;
    $account_search = array('accountId' => $id, 'osekNo' => '');
    $myCurl = curl_init();
    curl_setopt_array($myCurl, array(
        CURLOPT_URL => 'http://' . $request_ip . ':59310/account/search',
        CURLOPT_HTTPHEADER => $request_header,
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_POST => true,
        CURLOPT_POSTFIELDS => json_encode($account_search)
    ));
    $response = curl_exec($myCurl);
    if ($response === false) {
        $response = curl_error($myCurl);
    }
    curl_close($myCurl);

    create_log('http://' . $request_ip . ':59310/account/search', $account_search, $response);

    return $response;
}

function add_contact($id, $user_data) {
    global $request_header;
    global $request_ip;

    $myCurl = curl_init();
    curl_setopt_array($myCurl, array(
        CURLOPT_URL => 'http://' . $request_ip . ':59310/account',
        CURLOPT_HTTPHEADER => $request_header,
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_POST => true,
        CURLOPT_POSTFIELDS => json_encode($user_data)
    ));
    $response = curl_exec($myCurl);
    if ($response === false) {
        $response = curl_error($myCurl);
    }
    curl_close($myCurl);

    create_log('http://' . $request_ip . ':59310/contact', $user_data, $response);

    return $response;
}

function update_contact($id, $user_data) {
    global $request_header;
    global $request_ip;

    $myCurl = curl_init();
    curl_setopt_array($myCurl, array(
        CURLOPT_URL => 'http://' . $request_ip . ':59310/account',
        CURLOPT_HTTPHEADER => $request_header,
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_CUSTOMREQUEST => "PUT",
        CURLOPT_POSTFIELDS => json_encode($user_data)
    ));
    $response = curl_exec($myCurl);
    if ($response === false) {
        $response = curl_error($myCurl);
    }
    curl_close($myCurl);

    create_log('http://' . $request_ip . ':59310/contact', $user_data, $response);
}

function add_order($order_data) {
    global $request_header;
    global $request_ip;

    $myCurl = curl_init();
    curl_setopt_array($myCurl, array(
        CURLOPT_URL => 'http://' . $request_ip . ':59312/order',
        CURLOPT_HTTPHEADER => $request_header,
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_POST => true,
        CURLOPT_POSTFIELDS => json_encode($order_data)
    ));
    $response = curl_exec($myCurl);
    if ($response === false) {
        $response = curl_error($myCurl);
    }
    curl_close($myCurl);

    create_log('http://' . $request_ip . ':59312/order', $order_data, $response);
}

function cm_cron_update() {
    global $wpdb;
    $table_name = $wpdb->prefix . "manager_wooconnect";
    $table_name_logs = $wpdb->prefix . "manager_wooconnect_logs";
    $db_query = $wpdb->get_results("SELECT * FROM " . $table_name . " WHERE id = 1");
    $stockUpdateMethod = $db_query[0]->stockUpdateMethod;
    $itemIdField = $db_query[0]->itemIdField;
    $request_ip = $db_query[0]->ip;

    $order_header = array(
        'Content-type: application/json',
        'Authorization: Bearer ' . $db_query[0]->token,
    );

    $args = array(
        'post_type' => 'product',
        'posts_per_page' => -1
    );

    $loop = new WP_Query($args);

    $test = array();
    while ($loop->have_posts()) {
        $loop->the_post();
        global $product;

        $id = get_the_ID();
        $itemId = $id;
        $product = wc_get_product($id);
        if ($itemIdField == ITEM_SKU) {
            $itemId = $product->get_sku();
        }

        if (empty($itemId)) {
            continue;
        }

        // update product stock
        $myCurl = curl_init();
        $stock_url = "http://$request_ip:59311/item/$itemId/stock";
        curl_setopt_array($myCurl, array(
            CURLOPT_URL => $stock_url,
            CURLOPT_HTTPHEADER => $order_header,
            CURLOPT_RETURNTRANSFER => true
        ));
        $response = curl_exec($myCurl);            
        if ($response === false) {
            $response = curl_error($myCurl);
            create_log("Failed to update Stock: $stock_url", '', $response);
        } else {
            $response = json_decode($response, true);
            wc_update_product_stock($id, $response[$stockUpdateMethod], 'set');
            $test[$itemId] = $response[$stockUpdateMethod];
            create_log("Stock update: $stock_url", '', "Stock updated for Product $itemId: " . $response[$stockUpdateMethod]);
        }
        curl_close($myCurl);

        $search_product = array('itemId' => $itemId);

        $post_product = array(
            "id" => $itemId,
            "barcode" => $product->get_sku(),
            "providerId" => "",
            "itemNameHE" => $product->get_title(),
            "itemNameEN" => $product->get_title(),
            "unit" => "",
            "characteristic1" => "",
            "characteristic2" => "",
            "sortCode1" => "",
            "sortCode2" => "",
            "sortCode3" => "",
            "vatFlag" => "",
            "price1" => $product->get_price(),
            "price2" => $product->get_regular_price(),
            "price3" => $product->get_sale_price(),
            "price4" => "",
            "price5" => "",
            "price6" => "",
            "price7" => "",
            "price8" => "",
            "price9" => "",
            "price10" => "",
            "currencyCode1" => get_woocommerce_currency_symbol(),
            "currencyCode2" => "",
            "currencyCode3" => "",
            "currencyCode4" => "",
            "currencyCode5" => "",
            "currencyCode6" => "",
            "currencyCode7" => "",
            "currencyCode8" => "",
            "currencyCode9" => "",
            "currencyCode10" => "",
            "supplerId1" => "",
            "supplerId2" => "",
            "supplerId3" => "",
            "supplerId4" => "",
                //"createdDate" => $product->get_date_created()->date,
                //"updatedDate" => $product->get_date_modified()
        );

        $myCurl = curl_init();
        $item_search_url = "http://$request_ip:59311/item/search";
        curl_setopt_array($myCurl, array(
            CURLOPT_URL => $item_search_url,
            CURLOPT_HTTPHEADER => $order_header,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_POST => true,
            CURLOPT_POSTFIELDS => json_encode($search_product)
        ));
        $response = curl_exec($myCurl);
        if ($response === false) {
            $response = curl_error($myCurl);
            create_log($item_search_url, json_encode($search_product), $response);
        } else {
            create_log($item_search_url, json_encode($search_product), "Product have been found: $response");
        }
        curl_close($myCurl);

        $found_item = json_decode($response);
        $item_url = "http://$request_ip:59311/item";
        if ($found_item->rowCount === 0) {
            $myCurl = curl_init();
            curl_setopt_array($myCurl, array(
                CURLOPT_URL => $item_url,
                CURLOPT_HTTPHEADER => $order_header,
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_POST => true,
                CURLOPT_POSTFIELDS => json_encode($post_product)
            ));
            $response = curl_exec($myCurl);
            if ($response === false) {
                $response = curl_error($myCurl);
                create_log($item_url, json_encode($post_product), $response);
            } else {
                create_log($item_url, json_encode($post_product), "Product has been added with id: $response");
            }
            curl_close($myCurl);
        } else {
            $myCurl = curl_init();
            curl_setopt_array($myCurl, array(
                CURLOPT_URL => $item_url,
                CURLOPT_HTTPHEADER => $order_header,
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_CUSTOMREQUEST => "PUT",
                CURLOPT_POSTFIELDS => json_encode($post_product)
            ));
            $response = curl_exec($myCurl);
            if ($response === false) {
                $response = curl_error($myCurl);
                create_log($item_url, json_encode($post_product), $response);
            } else {
                create_log($item_url, json_encode($post_product), 'Product with id: ' . $response . ' has been updated');
            }
            curl_close($myCurl);
        }
    }
    
    create_log('cron_update finished', '', '');

    echo json_encode($test);
    die();
}

add_action('cm_cron_update_schedule', 'cm_cron_update');
add_action('wp_ajax_cm_cron_update', 'cm_cron_update');
