<?php

require_once dirname(__FILE__) . '/../config.php';

/* Render plugin's settings page */
function api_render_plugin_settings_page() {
    global $wpdb;
    $table_name = $wpdb->prefix . "manager_wooconnect";
    $table_name_logs = $wpdb->prefix . "manager_wooconnect_logs";
    $table_name_clients = $wpdb->prefix . "manager_wooconnect_clients";
    $db_query = $wpdb->get_results( "SELECT * FROM ".$table_name. " WHERE id = 1" );
    ?>

    <div class="manager-content">
        <div>
            <img src="<?php echo plugins_url('ManagerWooConnect/background.jpg'); ?>" alt="" style="max-height: 700px; height: 100%; margin-left: 100px;">
        </div>
        <div>
            <div class="description">
                <h2>Manager WooConnect</h2>

                <p>
                    תוסף לתוכנת מנג'ר לניהול העסק – תוכנת הנהלת חשבונות, מערכת מנג'ר מספקת פתרון מושלם לניהול העסק וגם תוכנה לניהול מלאי, ניתן לקבל את הפתרון של תוכנות מנג'ר בענן, לנהל את העסק במהירות מהענן. עם ממשק מלא לאתר המכירות שלכם!
                </p>

            </div>
            <table class="token-table">
                <tr>
                    <td class="settings-title">טוקן</td>
                    <td>
                        <?php
                        $secret_token = '***********************************' . mb_substr($db_query[0]->token, -4);
                        if(empty($db_query[0]->token)) { ?>
                            <input id="token" value="" data-token="" type="text" data-clicked="unlocked"/>
                        <?php }
                        else { ?>
                            <input id="token" value="<?php echo $secret_token; ?>" data-token="<?php echo $db_query[0]->token; ?>" type="text" data-clicked="locked" readonly/>
                        <?php } ?>
                        <input type="submit" value="עדכון טוקן" id="changeToken" class="submit button-primary">
                    </td>
                </tr>

                <tr>
                    <td class="settings-title">IP</td>
                    <td>
                        <input id="ipAddress" type="text" value="<?php echo $db_query[0]->ip; ?>">
                    </td>
                </tr>
            </table>

            <table class="swithers-table">
                <tr>
                    <td class="settings-title">צור לקוחות חדשים במנג'ר</td>
                    <td class="switchers-block">
                        <?php
                        if($db_query[0]->clientUrlState === 'true') {
                            $contact_on = 'checked';
                            $contact_off = '';
                        } else {
                            $contact_on = '';
                            $contact_off = 'checked';
                        }
                        ?>
                        <input type="radio" id="contactChoice1"
                               name="contact" value="on" <?php echo $contact_on; ?> >
                        <label for="contactChoice1">כבוי</label>

                        <input type="radio" id="contactChoice2"
                               name="contact" value="off" <?php echo $contact_off; ?> >
                        <label for="contactChoice2">פעיל</label>
                    </td>
                </tr>

                <tr>
                    <td class="settings-title">צור במנג'ר הזמנה ללקוח בביצוע הזמנה</td>
                    <td class="switchers-block">
                        <?php
                        if($db_query[0]->orderUrlState === 'true') {
                            $order_on = 'checked';
                            $order_off = '';
                        } else {
                            $order_on = '';
                            $order_off = 'checked';
                        }
                        ?>
                        <input type="radio" id="orderChoice1"
                               name="order" value="on" <?php echo $order_on; ?>>
                        <label for="productChoice1">כבוי</label>

                        <input type="radio" id="orderChoice2"
                               name="order" value="off" <?php echo $order_off; ?>>
                        <label for="orderChoice2">פעיל</label>
                    </td>
                </tr>

                <tr>
                    <td class="settings-title">צור מוצרים חדשים במנג'ר</td>
                    <td class="switchers-block">
                        <?php
                        if($db_query[0]->productUrlState === 'true') {
                            $products_on = 'checked';
                            $products_off = '';
                        } else {
                            $products_on = '';
                            $products_off = 'checked';
                        }
                        ?>
                        <input type="radio" id="productChoice1"
                               name="product" value="on" <?php echo $products_on; ?>>
                        <label for="productChoice1">כבוי</label>

                        <input type="radio" id="productChoice2"
                               name="product" value="off" <?php echo $products_off; ?>>
                        <label for="productChoice2">פעיל</label>
                    </td>
                </tr>

                <tr>
                    <td class="settings-title">צור במנג'ר תעודת משלוח ללקוח בביצוע הזמנה</td>
                    <td class="switchers-block">
                        <?php
                        if($db_query[0]->deliveryUrlState === 'true') {
                            $delivery_on = 'checked';
                            $delivery_off = '';
                        } else {
                            $delivery_on = '';
                            $delivery_off = 'checked';
                        }
                        ?>
                        <input type="radio" id="deliveryChoice1"
                               name="delivery" value="on" <?php echo $delivery_on; ?>>
                        <label for="deliveryChoice1">כבוי</label>

                        <input type="radio" id="deliveryChoice2"
                               name="delivery" value="off" <?php echo $delivery_off; ?>>
                        <label for="deliveryChoice2">פעיל</label>
                    </td>
                </tr>

                <tr>
                    <td class="settings-title">צור במנג'ר חשבונית ללקוח בביצוע הזמנה</td>
                    <td class="switchers-block">
                        <?php
                        if($db_query[0]->invoiceUrlState === 'true') {
                            $invoice_on = 'checked';
                            $invoice_off = '';
                        } else {
                            $invoice_on = '';
                            $invoice_off = 'checked';
                        }
                        ?>
                        <input type="radio" id="invoiceChoice1"
                               name="invoice" value="on" <?php echo $invoice_on; ?>>
                        <label for="invoiceChoice1">כבוי</label>

                        <input type="radio" id="invoiceChoice2"
                               name="invoice" value="off" <?php echo $invoice_off; ?>>
                        <label for="invoiceChoice2">פעיל</label>
                    </td>
                </tr>

            </table>

            <span style="font-size: 1.3em; font-weight: bold; margin-bottom: 15px; display: block;">עדכון מלאי באתר/עדכון מוצרים במנג'ר</span>
            <table class="update-stock">
                <tr>
                    <td class="settings-title">מזהה פריט</td>
                    <td>                        
                        <select name="" id="itemIdField">
                            <option value="<?php echo ITEM_ID; ?>" <?php if($db_query[0]->itemIdField === ITEM_ID) { echo 'selected="selected"';}  ?>>ווקומרס</option>
                            <option value="<?php echo ITEM_SKU; ?>" <?php if($db_query[0]->itemIdField === ITEM_SKU) { echo 'selected="selected"';}  ?>>מק"ט</option>
                        </select>
                    </td>
                </tr>
                <tr>
                    <td class="settings-title">עדכן מלאי לפי</td>
                    <td>                        
                        <select name="" id="stockUpdateMethod">
                            <option value="<?php echo STOCK_IN; ?>" <?php if($db_query[0]->stockUpdateMethod === STOCK_IN) { echo 'selected="selected"';}  ?>>יתרה במחסנים</option>
                            <option value="<?php echo STOCK_AVAILABLE; ?>" <?php if($db_query[0]->stockUpdateMethod === STOCK_AVAILABLE) { echo 'selected="selected"';}  ?>>מלאי זמין</option>
                        </select>
                    </td>
                </tr>
                <tr>
                    <td class="settings-title">תדירות עדכון</td>
                    <td>
                        <select name="" id="changeCron">
                            <option value="manual" <?php if($db_query[0]->stockStatus === 'manual') { echo 'selected="selected"';}  ?>>עדכון ידני בלבד</option>
                            <option value="half" <?php if($db_query[0]->stockStatus === 'half') { echo 'selected="selected"';}  ?>>אחת לחצי שעה</option>
                            <option value="hour" <?php if($db_query[0]->stockStatus === 'hour') { echo 'selected="selected"';}  ?>>אחת לשעה</option>
                            <option value="day" <?php if($db_query[0]->stockStatus === 'day') { echo 'selected="selected"';}  ?>>אחת ליום</option>
                        </select>                                                
                    </td>
                    <td>
                        <input type="submit" value="עדכן" class="submit button-primary" id="updateStock" <?php if($db_query[0]->stockStatus !== 'manual') { echo 'disabled="disabled"';}  ?>>
                    </td>
                </tr>                                
            </table>

            <input name="submit" class="submit button-primary" type="submit" value="שמור" id="saveChanges">

            <div class="logs" style="margin-top: 30px;">

                <div class="logs-content">
                    <h2>לוגים</h2>
                    <input name="submit" class="submit button-primary" type="submit" value="הצגת לוגים" id="showLogs">
                    <ul class="logs-list">
                        <?php

                        $logs = $wpdb->get_results( "SELECT * FROM ".$table_name_logs);

                        $log_item = 0;
                        foreach (array_reverse($logs) as $log) { ?>
                            <li class="log-item-<?php echo $log_item; ?>">
                                <span><?php echo $log->log_id; ?></span>
                                <span><?php echo $log->timestamp; ?></span>
                                <span class="url"><?php echo $log->level; ?></span>
                                <span><a class="submit button-primary show-response" data-res-id="<?php echo $log_item; ?>">הצגת תשובה</a></span>
                                <span><a class="submit button-primary show-request" data-req-id="<?php echo $log_item; ?>">הצגת פניה</a></span>
                                <div class="hidden-log res-log"><?php echo $log->message; ?></div>
                                <div class="hidden-log req-log"><?php echo $log->source; ?></div>
                            </li>
                        <?php
                        $log_item++;
                        } ?>
                    </ul>

                </div>
            </div>
        </div>

        <style>
            .url {
                width: 250px;
            }
            .logs-list {
                display: none;
                background-color: #ffffff;
                padding: 10px;
                height: 600px;
                overflow: scroll;
            }
            .logs-list li {
                padding: 5px 0;
                border-bottom: 1px solid #000000;
                display: inline-flex;
            }
            .logs-list li span {
                display: block;
                padding: 0 10px;
                border-left: 1px solid #000000;
            }
            .hidden-log {
                display: none;
            }
            /*pre {outline: 1px solid #ccc; padding: 5px; margin: 5px; }*/
            .string { color: green; }
            .number { color: darkorange; }
            .boolean { color: blue; }
            .null { color: magenta; }
            .key { color: red; }

            .close-btn {
                position: absolute;
                background: #ffffff;
                cursor: pointer;
            }

            .close-btn img {
                width: 25px!important;
                height: 25px!important;
            }
            .close-button {
                background-color: white;
                position: relative;
                cursor: pointer;
            }
            .close-button-content {
                position: absolute;
                left: -75px;
                bottom: -30px;
                background-color: white;
            }
            .close-button img {
                width: 25px!important;
                height: 25px!important;
            }
        </style>

        <div class="pop-up-notices">
            <div class="pop-up-notices__wrapper" id="notice"></div>
        </div>
    </div>

    <script>
        const popUp = jQuery('.pop-up-notices')
        const popUpContent = jQuery('#notice')

        function clBtn() {
            jQuery('.close-button-content').on('click', function () {
                jQuery(popUp).fadeOut().css({'overflow' : ''})
                setTimeout(() => {
                    jQuery(popUpContent).css({ 'font-size' : '', 'top' : '', 'direction' : '', 'transform' : '' })
                    jQuery(popUpContent).html('')
                }, 600)
            })
        }


        jQuery(popUp).on('click', function (e) {
            if(e.target.className === 'pop-up-notices') {
                jQuery(popUp).fadeOut().css({'overflow' : ''})
                setTimeout(() => {
                    jQuery(popUpContent).css({ 'font-size' : '', 'top' : '', 'direction' : '', 'transform' : '' })
                    jQuery(popUpContent).html('')
                }, 600)
            }
        })

        jQuery('.show-request').on('click', function () {
            const reqId = jQuery(this).attr('data-req-id')
            const request = jQuery('.log-item-'+reqId).find('.req-log').html()
            const cont = JSON.parse(request)

            function output(inp) {
                jQuery(popUp).css({ 'overflow' : 'scroll' }).fadeIn()
                jQuery(popUpContent).html('<pre>'+inp+'</pre><div class="close-button"><div class="close-button-content"><img src="<?php echo plugins_url("ManagerWooConnect/close.png"); ?>"></div></div>').css({ 'font-size' : '1rem', 'top' : '0', 'direction' : 'ltr', 'transform' : 'translate(-50%, 0)' })
                clBtn()
            }

            function syntaxHighlight(json) {
                json = json.replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;');
                return json.replace(/("(\\u[a-zA-Z0-9]{4}|\\[^u]|[^\\"])*"(\s*:)?|\b(true|false|null)\b|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?)/g, function (match) {
                    let cls = 'number';
                    if (/^"/.test(match)) {
                        if (/:$/.test(match)) {
                            cls = 'key';
                        } else {
                            cls = 'string';
                        }
                    } else if (/true|false/.test(match)) {
                        cls = 'boolean';
                    } else if (/null/.test(match)) {
                        cls = 'null';
                    }
                    return '<span class="' + cls + '">' + match + '</span>';
                });
            }

            const str = JSON.stringify(cont, undefined, 4);

            output(syntaxHighlight(str))

        })

        jQuery('.show-response').on('click', function () {
            const resId = jQuery(this).attr('data-res-id')
            console.log(resId)
            const res = jQuery('.log-item-'+resId).find('.res-log').html()
            jQuery(popUp).css({ 'overflow' : 'scroll' }).fadeIn()
            jQuery(popUpContent).html('<div>'+res+'</div><div class="close-button"><div class="close-button-content"><img src="<?php echo plugins_url("ManagerWooConnect/close.png"); ?>"></div></div>').css({ 'font-size' : '1rem',  'direction' : 'ltr' })
            clBtn()
        })

        jQuery('#showLogs').on('click', function () {
            if(!jQuery(this).hasClass('logs-shown')) {
                jQuery('.logs-list').slideDown()
                jQuery(this).val('להסתיר לוגים').addClass('logs-shown')
            } else {
                jQuery('.logs-list').slideUp()
                jQuery(this).val('הצגת לוגים').removeClass('logs-shown')
            }
        })

        jQuery('#changeToken').on('click', function () {

            const token = jQuery('#token')

            if( token.attr('data-clicked') === 'locked' ) {
                token.attr('data-clicked', 'unlocked');
                token.attr('readonly', false).val('');
            } else {
                token.attr('data-clicked', 'locked');
                token.attr('readonly', true);
            }

        })

        jQuery('#saveChanges').on('click', function () {
            let contactState, productState, orderState, deliveryState, invoiceState, update
            if(jQuery('input[name="contact"]:checked').val() === 'on') { contactState = 'true' } else { contactState = 'false' }
            if(jQuery('input[name="product"]:checked').val() === 'on') { productState = 'true' } else { productState = 'false' }
            if(jQuery('input[name="order"]:checked').val() === 'on') { orderState = 'true' } else { orderState = 'false' }
            if(jQuery('input[name="delivery"]:checked').val() === 'on') { deliveryState = 'true' } else { deliveryState = 'false' }
            if(jQuery('input[name="invoice"]:checked').val() === 'on') { invoiceState = 'true' } else { invoiceState = 'false' }        

            let tokenVal = jQuery('#token').val()
            let tokenNew

            if (tokenVal.indexOf("*") === 0) {
                tokenNew = jQuery('#token').attr('data-token')
            } else {
                tokenNew = jQuery('#token').val()
            }

            const data_json = {
                token: tokenNew,
                ip: jQuery('#ipAddress').val(),
                clientUrl: jQuery('#contact').val(),
                clientUrlState: contactState,
                orderUrl: jQuery('#order').val(),
                orderUrlState: orderState,
                productUrl: jQuery('#product').val(),
                productUrlState: productState,
                deliveryUrl: jQuery('#delivery').val(),
                deliveryUrlState: deliveryState,
                invoiceUrl: jQuery('#invoice').val(),
                invoiceUrlState: invoiceState,
                stockStatus: jQuery('#changeCron').val(),
                stockUpdateMethod: jQuery('#stockUpdateMethod').val(),
                itemIdField: jQuery('#itemIdField').val()                
            };

            jQuery.ajax({
                type: "POST",
                url: ajaxurl,
                async: true,
                dataType: "text",
                data: 'action=wooconnect&data='+JSON.stringify(data_json),
                beforeSend: function(r) {
                    jQuery('#saveChanges').attr('disabled', 'disabled')
                },
                success: function(r){
                    jQuery('#notice').html('כל השינויים נשמרו בהצלחה')
                    jQuery('.pop-up-notices').fadeIn()
                    setTimeout(() => {
                        jQuery('.pop-up-notices').fadeOut()
                    }, 1000)
                    jQuery('#saveChanges').removeAttr('disabled')
                }
            })
        })

        jQuery('#updateStock').on('click', function () {
            jQuery.ajax({
                type: "POST",
                url: ajaxurl,
                async: true,
                dataType: "text",
                data: 'action=cm_cron_update',
                beforeSend: function(r) {
                    jQuery('#notice').html('מעדכן מלאי/מוצרים, אנא אל תסגרו דפדפן');
                    jQuery('.pop-up-notices').fadeIn();
                },
                success: function (res) {
                    //console.log(JSON.parse(res));
                    setTimeout(() => {
                        jQuery('.pop-up-notices').fadeOut();
                    }, 1000);
                }
            });                                    
        });

        function update_product(id) {
            jQuery.ajax({
                type: "POST",
                url: ajaxurl,
                async: true,
                dataType:"text",
                data: 'action=wooconnectputitem&id='+id.toString(),
                success: function (res) {
                    console.log('The product has been updated...', res)
                }
            })
        }
    </script>

    <style>
        .description {
            max-width: 500px;
        }
        .description p {
            font-size: 1.3em;
        }
        .description h2 {

        }
        .switchers-block {
            direction: ltr;
        }
        .manager-content {
            display: flex;
            padding-top: 50px;
        }
        .manager-content table select {
            margin-right: 0;
        }
        .manager-content img {
            height: 100vh;
        }
        .token-table .settings-title,
        .update-stock .settings-title {
            font-size: 1.3em;
            font-weight: bold;
            width: 100px;
        }
        .swithers-table .settings-title {
            font-size: 1.3em;
            font-weight: bold;
            width: 350px;
        }
        .swithers-table {
            margin-top: 30px;
            margin-bottom: 30px;
        }
        .update-stock {
            margin-bottom: 30px;
        }
        table input[type=text] {
            width: 300px;
        }
        table select {
            width: 300px;
            margin-right: 20px;
        }
        table input[type=radio] {
            margin-left: 20px;
        }
        table input[type=checkbox] {
            margin-left: 20px;
        }
        table input[type=submit] {
            margin-top: 50px;
        }

        .pop-up-notices {
            display: none;
            position: fixed;
            width: 100%;
            height: 100%;
            top: 0;
            right: 0;
            background: rgba(0, 0, 0, .7);
        }
        .pop-up-notices__wrapper {
            position: absolute;
            top: 50%;
            left: 50%;
            transform: translate(-50%, -50%);
            padding: 40px;
            border-radius: 10px;
            background-color: #ffffff;
            font-size: 1.5rem;
        }
    </style>

<?php
}

